﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinToolbars;
using System.Drawing;
using Infragistics.Win.AppStyling;

namespace _92210
{
    class MyDraw:IUIElementDrawFilter
    {
        #region IUIElementDrawFilter Members

        Pen separatorPan = new Pen(Color.Black);

        public Pen SeparatorPane
        {
            get { return separatorPan; }
            set
            {
                if (value == null)
                    throw new ArgumentNullException();
                separatorPan = value;
            }

        }

        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            bool ret = false;
            if (drawParams.Element is PopupMenuSeparatorItemUIElement)
            {
                UIElement par = drawParams.Element.Parent;
                UIElement prev = par.ChildElements[par.ChildElements.IndexOf(drawParams.Element) - 1].GetDescendant(typeof(TextUIElement));
                Point EndPoint = prev.Rect.Location;
                EndPoint.Offset(prev.Rect.Width - 1, 0);
                Point StartPoint = prev.Rect.Location;
                StartPoint.Offset(1, 0);
                drawParams.Graphics.DrawLine(separatorPan, StartPoint, EndPoint);
                ret =  true;
            }
            if (drawParams.Element is FloatingToolbarUIElement)
            {
                AppearancePropFlags flags = AppearancePropFlags.BackColor;
                AppearanceData data = new AppearanceData();
                data.BackColor = Color.Red;
                UIRole role = ((Infragistics.Win.UltraWinToolbars.FloatingToolbarUIElement)(drawParams.Element.ControlElement)).ToolbarsManager.ComponentRole.GetRole(134);
                role.ResolveAppearance(ref data, ref flags, RoleState.Normal);
                if (data.HasPropertyBeenSet(AppearancePropFlags.BackColor))
                    drawParams.AppearanceData.BackColor = data.BackColor;

            }
            
            return ret;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is PopupMenuSeparatorItemUIElement)
            {
                return DrawPhase.BeforeDrawElement;
            }

            if ( drawParams.Element is FloatingToolbarUIElement)
                return DrawPhase.BeforeDrawBackColor;
            return DrawPhase.None;

        }

        #endregion
    }
}
